'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n    0%   { transform: scale(1.0,1.0); }\n    50%  { transform: scale(0.9,0.9); }\n    100% { transform: scale(1.0,1.0); }\n  '], ['\n    0%   { transform: scale(1.0,1.0); }\n    50%  { transform: scale(0.9,0.9); }\n    100% { transform: scale(1.0,1.0); }\n  ']),
    _templateObject2 = _taggedTemplateLiteral(['\n    0%   { transform: scale(0.5,0.5); }\n    50%  { transform: scale(0.7,0.7); }\n    100% { transform: scale(0.5,0.5); }\n  '], ['\n    0%   { transform: scale(0.5,0.5); }\n    50%  { transform: scale(0.7,0.7); }\n    100% { transform: scale(0.5,0.5); }\n  ']),
    _templateObject3 = _taggedTemplateLiteral(['\n    0%   { transform: scale(0.5,0.5); }\n    50%  { transform: scale(1.3,1.3); }\n    100% { transform: scale(1,1); }\n  '], ['\n    0%   { transform: scale(0.5,0.5); }\n    50%  { transform: scale(1.3,1.3); }\n    100% { transform: scale(1,1); }\n  ']),
    _templateObject4 = _taggedTemplateLiteral(['\n  color: ', ';\n  display: flex;\n  align-items: center;\n  flex-direction: row;\n'], ['\n  color: ', ';\n  display: flex;\n  align-items: center;\n  flex-direction: row;\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n  transform-origin: 50% 50%;\n  animation: ', ';\n'], ['\n  transform-origin: 50% 50%;\n  animation: ', ';\n']),
    _templateObject6 = _taggedTemplateLiteral(['\n  fill: ', ';\n  cursor: ', ';\n'], ['\n  fill: ', ';\n  cursor: ', ';\n']),
    _templateObject7 = _taggedTemplateLiteral(['\n  font-size: 75%;\n  color: gray;\n'], ['\n  font-size: 75%;\n  color: gray;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var COLOR = {
  busy: 'gray',
  on: 'red',
  off: 'black',
  error: 'gray'
};

var KEYFRAMES = {
  error: (0, _styledComponents.keyframes)(_templateObject) + ' 0.2s 2',
  busy: (0, _styledComponents.keyframes)(_templateObject2) + ' 1.0s infinite',
  on: (0, _styledComponents.keyframes)(_templateObject3) + ' 0.5s',
  off: (0, _styledComponents.keyframes)(_templateObject3) + ' 0.5s'
};
var Container = _styledComponents2.default.div(_templateObject4, function (props) {
  return COLOR[props.state];
});
var HeartContainer = _styledComponents2.default.svg(_templateObject5, function (props) {
  return KEYFRAMES[props.state];
});
var Heart = _styledComponents2.default.path(_templateObject6, function (props) {
  return COLOR[props.state];
}, function (props) {
  return props.state === 'busy' ? 'normal' : 'pointer';
});
var Error = _styledComponents2.default.span(_templateObject7);

exports.default = function (_ref) {
  var error = _ref.error,
      busy = _ref.busy,
      count = _ref.count,
      reaction = _ref.reaction,
      props = _objectWithoutProperties(_ref, ['error', 'busy', 'count', 'reaction']);

  var state = error ? 'error' : busy ? 'busy' : reaction ? 'on' : 'off';
  return _react2.default.createElement(
    Container,
    _extends({}, props, { state: state }),
    _react2.default.createElement(
      HeartContainer,
      { width: 20, height: 15, state: state },
      _react2.default.createElement(Heart, { d: 'M12.3,0c0,0-2.1-0.3-3.8,2.4C6.8-0.3,4.7,0,4.7,0S0,0,0,4.9S8.5,15,8.5,15S17,9.9,17,4.9S12.3,0,12.3,0z', state: state })
    ),
    !error && count,
    error && _react2.default.createElement(
      Error,
      null,
      error.message
    )
  );
};